package application;

import java.io.Serializable;
import java.util.Date;

public class Status implements Serializable {
	private static final long serialVersionUID = 201007242141L;
	
	private String statusId;
	private String text;
	private String author;
	private String authorId;
	private long time;
	
	/*for gossip dissemination*/
	private boolean gossip;
	private long gossiptime;
	private int  gossiphops;
	
	public Status(String statusId, String text, String author, String authorId, long time) {
		this.statusId = statusId;
		this.text = text;
		this.author = author;
		this.authorId = authorId;
		this.time = time;
	}
	
	public Status(String statusId, String text, String author, String authorId, long time, boolean g) {
		this(statusId, text, author, authorId, time);
		this.gossip = g;
	}
	
	public String toString() {
		String dt = new Date(time).toString();
		return author + " ----> " + text + " @" + dt + "\n";
	}
	
	/******************Getters*************************/
	public String getStatusId() {
		return statusId;
	}
	
	public String getText() {
		return text;
	}
	
	public String getAuthor() {
		return author;
	}
	
	public String getAuthorId() {
		return authorId;
	}
	
	public long getTime() {
		return time;
	}
	
	public boolean getGossipOrNot() {
		return gossip;
	}
	
	public long getGossipTime() {
		return gossiptime;
	}
	
	public int getGossipHops() {
		return gossiphops;
	}
	
	/**********************Setters**************************/
	public void setGossipOrNot(boolean g) {
		this.gossip = g;
	}
	
	public void setGossipTime(long gt) {
		this.gossiptime = gt;
	}
	
	public void addGossipTime(long gt) {
		this.gossiptime += gt;
	}
	
	public void setGossipHops(int h) {
		this.gossiphops = h;
	}
}
