package toolBox;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.StringWriter;
import java.io.PrintWriter;
import java.util.Date;

public class ErrorLog {
	private String ErrorLogFilePath;
	private BufferedWriter ErrorWriter;
	
	public ErrorLog(String ErrorLogFilePath){
		this.ErrorLogFilePath = ErrorLogFilePath;
		try {
			File NewLogFile = new File(this.ErrorLogFilePath);
			if(NewLogFile.exists() == false)
				NewLogFile.createNewFile();
			ErrorWriter = new BufferedWriter(new FileWriter(NewLogFile, true));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void logError(String ErrString){
		log("Error: " + new Date().toString() + ": " + ErrString);
	}
	
	public void logInfo(String InfoString){
		log("Info: " + new Date().toString() + ": " + InfoString);
	}
	
	public void logException(Exception e){
		
		StringWriter sw = null;
		PrintWriter pw = null;
		
		try{
			sw = new StringWriter();
		    pw = new PrintWriter(sw, true);
		    
		    e.printStackTrace(pw);
		    
		    log("Exception: " + new Date().toString() + ": " + sw.getBuffer().toString().trim());
		}catch(Exception e1){
			e1.printStackTrace();
		}finally{
	    	try{
		    	if(sw != null)
		    		sw.close();
		    	if(pw != null)
		    		pw.close();
			} catch (IOException e2){
				e2.printStackTrace();
			}
		}
	}
	
	public void log(String SomeString){
		try {
			ErrorWriter.write(SomeString);
			ErrorWriter.newLine();
			ErrorWriter.flush();
		} catch (Exception e) {
			// We cannot write the content to the log file, thus we print it in the console.
			if(e.toString().contains("Insufficient system resources exist to complete the requested service"))
				System.out.println(new Date().toString() + "\nInsufficient resources to record logs in: " + ErrorLogFilePath
						+ "\nLog content: " + SomeString);
			else
				System.out.println(new Date().toString() + ": " + e.toString());
		}
	}
	
	public void closeLog(){
		try{
			ErrorWriter.close();
		}catch(Exception e) {
			e.printStackTrace();
		}
	}
}
